c/* %W%      latest revision %G% %U% */   
      subroutine FFPN( q2, fcp, fcn )
************************************************************************

c *** see R.H. Landau's program LPOTT, 1981

c *** Proton charge ff (also proton magnetic and neutron magnetic
c *** if the number of rhos = 1)
c *** Neutron charge form factor
c *** q in fm-1

************************************************************************

      implicit real*8 (a-h, m, o-z)

      data x, un, mn / 18.2d+0, -1.91315d+0, 4.7548d+0/

************************************************************************
************************************************************************

             x = 18.2d0
             un = -1.91315d0
             mn = 4.7548d0

      fcp = 1./( (1. + q2/x)**2 )
      fcn = -(un * q2 * 0.25/mn/mn) * fcp

      RETURN
      end
